###############################################################################
#
# Categoryץ饰Υϥɥ
#
###############################################################################
package plugin::category::CategoryHandler;
use strict;
use plugin::category::CategoryCache;
#==============================================================================
# 󥹥ȥ饯
#==============================================================================
sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}

#==============================================================================
# ϥɥ᥽å
#==============================================================================
sub do_action {
	my $self = shift;
	my $wiki = shift;
	my $cgi = $wiki->get_CGI;
	
	my $source = "";
	my $action  = $cgi->param("action");
	
	if ( $action eq "CATEGORY" ) {
		$source = $self->get_category_list($wiki);
	}
	
	my $html = "";
	my $category  = $cgi->param("category");
	if ( $category eq "" ) {
		eval("use plugin::info::OutlineParser;");
		my $parser = plugin::info::OutlineParser->new($wiki);
		$html .= "<div class=\"header\">\n".$parser->outline($source)."\n</div>\n<p>\n";
	}
	
	$cgi->param("page","");
	$html .= $wiki->process_wiki($source);
	
	if ( $category eq "" ) {
		$wiki->set_title("ƥΰ");
	} else {
		$wiki->set_title("ƥ:".$category);
	}
	return $html;
}

sub get_category_list {
	my $self = shift;
	my $wiki = shift;
	my $cgi = $wiki->get_CGI;
	
	my $category  = $cgi->param("category");
	my $cachefile = $wiki->config('log_dir')."/category.cache";
	
	if(!(-e $cachefile)){
		&plugin::category::CategoryCache::create_cache($wiki);
	}
	my $result = &Util::load_config_hash(undef,$cachefile);
	
	my $buf = "";
	my $pno = "";
	my $text = "";
	my @keys = ();
	
	if ($category eq "") {
		@keys = sort(keys(%$result));
	} else {
		push(@keys, $category);
	}
	
	foreach my $key (@keys){
		# ƥΥڡڡ̾Τ¤ؤ
		my @pages = sort{
			my ($a_,$b_) = ($a,$b);
			if ( $a =~ /([0-9][0-9][0-9][0-9])\-([0-9][0-9]?)\-([0-9][0-9]?)/ ) {
				$a_ = sprintf("%s%04d-%02d-%02d%s",$`,$1,$2,$3,$');
			}
			if ( $b =~ /([0-9][0-9][0-9][0-9])\-([0-9][0-9]?)\-([0-9][0-9]?)/ ) {
				$b_ = sprintf("%s%04d-%02d-%02d%s",$`,$1,$2,$3,$');
			}
			$a_ cmp $b_;
		} split(/\t/,$result->{$key});
		
		# ڡꥹȺ
		my $buf2 = "";
		foreach my $pagename (@pages){
			if($wiki->can_show($pagename)){
				my @buf = $self->get_category_text($wiki,$key,$pagename);
				foreach (@buf) {
					$pno  = $_->{'pno'};
					$text = $_->{'text'};
					if ( $pno > 0 ) { $pno = "#p".($pno-1); };
					$buf2 .= "*[$pagename|./".$wiki->create_url({page=>$pagename}).$pno."]".
					        (($text ne "")?" - ".$text."\n":"\n");
				}
			}
		}
		
		# ڡʤϥƥɽˤ
		next if ( $buf2 eq "" );
		
		# ƥꥹȽ
		$buf .= "!!!".$key."\n".$buf2."\n";
	}
	if ( $category ne "" && $buf eq "" ) {
		return &Util::paragraph_error("ƥ꡼Ĥޤ","WIKI");
	}
	return $buf;
}

#==============================================================================
# ڡ饫ƥȡα¦ʸ
#==============================================================================
sub get_category_text {
	my $self = shift;
	my $wiki = shift;
	my $category = shift;
	my $pagename = shift;
	my $cgi  = $wiki->get_CGI;
	my $text = "";
	my $pno = "";
	my @buf;
	
	my $source = $wiki->get_page($pagename);
	foreach my $line (split(/\n/,$source)) {
		if ( $line =~ /^!+.*/ ) { $pno++; };
		if ( $line =~ /{{category ( *|[^}]+,)?$category(,[^}]+)?}} *(.*)$/ ) {
			$text = $3;
			$text =~ s/{{category [^}]+}}//g;
			my $buf = { 'pno' => $pno, 'text' => $text};
			push(@buf, $buf);
		}
	}
	return @buf;
}

1;
